extern crate proc_macro2;
extern crate quote;
extern crate syn;

extern crate proc_macro;

use proc_macro::TokenStream; // 用于生成代码
use syn::{parse_macro_input, DeriveInput}; // 用于解析宏输入

mod responsable;
mod route;

// 定义一个名为`responsable`的过程宏
// #[proc_macro_derive(Responsable, attributes(status, headers))]
#[proc_macro_derive(Responsable)]
pub fn responsable(input: TokenStream) -> TokenStream {
    // 解析宏输入为`DeriveInput`
    let input = parse_macro_input!(input as DeriveInput);

    // 根据数据类型生成不同的代码
    responsable::gen_responsable(input)
}

#[proc_macro_attribute]
pub fn route(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_route(attr, item)
}

#[proc_macro_attribute]
pub fn get(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_get_route(attr, item)
}

#[proc_macro_attribute]
pub fn post(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_post_route(attr, item)
}

#[proc_macro_attribute]
pub fn put(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_put_route(attr, item)
}

#[proc_macro_attribute]
pub fn delete(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_delete_route(attr, item)
}

#[proc_macro_attribute]
pub fn option(attr: TokenStream, item: TokenStream) -> TokenStream {
    route::gen_option_route(attr, item)
}